您的位置:首页 > 其它

HDU 2845 Beans (DP)

2014-12-13 18:11 399 查看
Beans
Time Limit:1000MS Memory Limit:32768KB 64bit IO Format:%I64d & %I64u
Submit Status Practice HDU 2845

Description

Bean-eating is an interesting game, everyone owns an M*N matrix, which is filled with different qualities beans. Meantime, there is only one bean in any 1*1 grid. Now you want to eat the beans and collect the qualities, but everyone must obey by the following rules: if you eat the bean at the coordinate(x, y), you can’t eat the beans anyway at the coordinates listed (if exiting): (x, y-1), (x, y+1), and the both rows whose abscissas are x-1 and x+1.



Now, how much qualities can you eat and then get ?

Input

There are a few cases. In each case, there are two integer M (row number) and N (column number). The next M lines each contain N integers, representing the qualities of the beans. We can make sure that the quality of bean isn't beyond 1000, and 1<=M*N<=200000.

Output

For each case, you just output the MAX qualities you can eat and then get.

Sample Input

4 6
11 0 7 5 13 9
78 4 81 6 22 4
1 40 9 34 16 10
11 22 0 33 39 6

Sample Output

242

思路:
STEP_1:先以行为单位来算,设DP数组存的是以此位置为起点能得到的最大值,在此前提下,DP[i][j]因为相邻的不能走,所以要么加上DP[i][j + 2],要么加上DP[i][j + 3] (假设不越界),取最大的那个就好。从右往左依次计算这一行每个元素的DP值,记录下最大的,放到DP[i][0]里。
STEP_2:重复第一步,只不过对象换成了DP数组里每行0号单元的值,因为此单元放的是此行内的最大值。从上往下,每次选定一行后设此行为最终答案里最下面那行,因为选定一行之后它的上面和下面那一行就废掉了,所以每一行要么加上它上面第二行,要么加上它上面第三行。同理,记录下最大值,最大值即答案。(实际上答案不是最后一行就是倒数第二行,因为没有负数,只会越加越大,不过只有1行的时候就会越界,虽然HDU上的数据貌似没1行的)。

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#define    MAX    200105

int    main(void)
{
int    n,m;
int    max,temp_1,temp_2,ans;

while(scanf("%d%d",&n,&m) != EOF)
{
int    dp[n + 10][m + 10];

memset(dp,0,sizeof(dp));
for(int i = 1;i <= n;i ++)
for(int j = 1;j <= m;j ++)
scanf("%d",&dp[i][j]);

for(int i = 1;i <= n;i ++)
{
max = dp[i][m];
for(int j = m;j >= 1;j --)
{
dp[i][j] += dp[i][j + 2] > dp[i][j + 3] ? dp[i][j + 2] : dp[i][j + 3];
max = max > dp[i][j] ? max : dp[i][j];
}
dp[i][0] = max;
}

max = dp[1][0];
dp[3][0] += dp[1][0];
for(int i = 4;i <= n;i ++)
{
dp[i][0] += dp[i - 2][0] > dp[i - 3][0] ? dp[i - 2][0] : dp[i - 3][0];
max = max > dp[i][0] ? max : dp[i][0];
}

printf("%d\n",max);
}

return    0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: